"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.between = exports.payloadIntoKey = exports.withEventValue = exports.ensureAndEvolveKey = exports.ensureKey = exports.ensureArray = exports.catchWith = exports.awaitWith = exports.nilOrEmpty = exports.hasnt = void 0;

var R = _interopRequireWildcard(require("ramda"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { if (i % 2) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } else { Object.defineProperties(target, Object.getOwnPropertyDescriptors(arguments[i])); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var hasnt = R.complement(R.has);
exports.hasnt = hasnt;
var nilOrEmpty = R.converge(R.or, [R.isNil, R.isEmpty]);
exports.nilOrEmpty = nilOrEmpty;
var awaitWith = R.curry(function (then, promise) {
  return promise.then(then);
});
exports.awaitWith = awaitWith;
var catchWith = R.curry(function (catcher, promise) {
  return promise["catch"](catcher);
});
exports.catchWith = catchWith;
var ensureArray = R.unless(R.is(Array), R.of);
exports.ensureArray = ensureArray;
var ensureKey = R.curry(function (defaultValue, key) {
  return R.when(hasnt(key), R.assoc(key, defaultValue));
});
exports.ensureKey = ensureKey;
var ensureAndEvolveKey = R.curry(function (defaultValue, key, evolver) {
  return R.compose(R.evolve(_defineProperty({}, key, evolver)), ensureKey(defaultValue, key));
});
exports.ensureAndEvolveKey = ensureAndEvolveKey;

var withEventValue = function withEventValue(fn) {
  return function (ev) {
    return fn(ev.target.value);
  };
};

exports.withEventValue = withEventValue;

var payloadIntoKey = function payloadIntoKey(key) {
  return function (state, action) {
    return _objectSpread({}, state, _defineProperty({}, key, action.payload));
  };
};

exports.payloadIntoKey = payloadIntoKey;

var between = function between(low, high) {
  return R.both(R.gte(R.__, low), R.lt(R.__, high));
};

exports.between = between;